/*
 * Copyright 2013 Graham Smith
 */
package co.uk.wobblycogs.samplefx5;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;

/**
 *
 * @author Graham Smith
 */
public class SampleFX5 extends Application {

	private static SampleFX5 application;
	private static Stage stage;

	public SampleFX5() {
	}

	@Override
	public void init() throws Exception {
		super.init();
		//Provide a reference to the application so that controllers can share items.
		setApplication(this);
	}

	@Override
	public void start(Stage stage) throws Exception {
		setStage(stage);
		try {
			Pane pane = FXMLLoader.load(getClass().getResource("/resources/fxml/SampleFX5.fxml"));
			Scene scene = new Scene(pane, 1020, 720, false);
			stage.setTitle("SampleFX 5");
			stage.setScene(scene);
			stage.show();
		} catch (IOException ex) {
			Logger.getLogger(getClass().getName()).log(Level.SEVERE, "Failed to load FXML", ex);
		}
	}

	/**
	 * The main() method is ignored in correctly deployed JavaFX application.
	 * main() serves only as fallback in case the application can not be
	 * launched through deployment artifacts, e.g., in IDEs with limited FX
	 * support. NetBeans ignores main().
	 *
	 * @param args the command line arguments
	 */
	public static void main(String[] args) {
		launch(args);
	}

	/**
	 * Should be called only once at application initialisation.
	 *
	 * @param app
	 */
	private static void setApplication(SampleFX5 app) {
		application = app;
	}

	/**
	 * To be used by the rest of the application when it requires access to
	 * application features.
	 *
	 * @return
	 */
	public static SampleFX5 getApplication() {
		return application;
	}

	public static Stage getStage() {
		return stage;
	}

	private static void setStage(Stage stage) {
		SampleFX5.stage = stage;
	}
}
