/*
 * Copyright 2013 Graham Smith
 */
package co.uk.wobblycogs.samplefx5;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXMLLoader;
import javafx.scene.Node;
import javafx.scene.control.Tab;
import javafx.scene.control.TabPane;

/**
 *
 * @author Graham Smith
 */
final class TabCreator implements EventHandler<ActionEvent> {

	private TabPane tabPane;
	private String friendlyName;
	private String name;
	private String fxmlResource;

	public TabCreator(TabPane tabPane, String friendlyName, String name, String fxmlResource) {
		this.tabPane = tabPane;
		this.friendlyName = friendlyName;
		this.name = name;
		this.fxmlResource = fxmlResource;
	}

	@Override
	public void handle(ActionEvent t) {
		Tab tab = new Tab(friendlyName);
		tab.setId(name);
		try {
			Node node = FXMLLoader.load(getClass().getResource(fxmlResource));
			tab.setContent(node);
		} catch (IOException ex) {
			Logger.getLogger(getClass().getName()).log(Level.SEVERE, "Failed to create tab", ex);
		}
		tabPane.getTabs().add(tab);
		tabPane.getSelectionModel().select(tab);
	}
}
